From 7c00e881edae1c266cea122a20c9149d6a2f535d Mon Sep 17 00:00:00 2001
From: tteckster <tteckster@gmail.com>
Date: Tue, 22 Feb 2022 10:33:34 -0500
Subject: [PATCH] Create unprivileged-node-red.sh

---
 unprev/unprivileged-node-red.sh | 116 ++++++++++++++++++++++++++++++++
 1 file changed, 116 insertions(+)
 create mode 100644 unprev/unprivileged-node-red.sh

diff --git a/unprev/unprivileged-node-red.sh b/unprev/unprivileged-node-red.sh
new file mode 100644
index 00000000..e826c840
--- /dev/null
+++ b/unprev/unprivileged-node-red.sh
@@ -0,0 +1,116 @@
+#!/usr/bin/env bash
+
+BL=`echo "\033[36m"`
+RD=`echo "\033[01;31m"`
+CM='\xE2\x9C\x94\033'
+GN=`echo "\033[1;92m"`
+CL=`echo "\033[m"`
+while true; do
+    read -p "This will create a New Unprivileged Node-Red LXC. Proceed(y/n)?" yn
+    case $yn in
+        [Yy]* ) break;;
+        [Nn]* ) exit;;
+        * ) echo "Please answer yes or no.";;
+    esac
+done
+clear
+function header_info {
+echo -e "${RD}
+
+      _   _           _             _____          _ 
+     | \ | |         | |           |  __ \        | |
+     |  \| | ___   __| | ___ ______| |__) |___  __| |
+     |     |/ _ \ / _  |/ _ \______|  _  // _ \/ _  |
+     | |\  | (_) | (_| |  __/      | | \ \  __/ (_| |
+     |_| \_|\___/ \__,_|\___|      |_|  \_\___|\__,_|
+                                                 
+                                                 
+${CL}"
+}
+
+header_info
+
+
+set -o errexit
+set -o errtrace
+set -o nounset
+set -o pipefail
+shopt -s expand_aliases
+alias die='EXIT=$? LINE=$LINENO error_exit'
+trap die ERR
+trap cleanup EXIT
+
+function error_exit() {
+  trap - ERR
+  local DEFAULT='Unknown failure occured.'
+  local REASON="\e[97m${1:-$DEFAULT}\e[39m"
+  local FLAG="\e[91m[ERROR] \e[93m$EXIT@$LINE"
+  msg "$FLAG $REASON"
+  [ ! -z ${CTID-} ] && cleanup_ctid
+  exit $EXIT
+}
+function warn() {
+  local REASON="\e[97m$1\e[39m"
+  local FLAG="\e[93m[WARNING]\e[39m"
+  msg "$FLAG $REASON"
+}
+function info() {
+  local REASON="$1"
+  local FLAG="\e[36m[INFO]\e[39m"
+  msg "$FLAG $REASON"
+}
+function msg() {
+  local TEXT="$1"
+  echo -e "$TEXT"
+}
+function cleanup_ctid() {
+  if $(pct status $CTID &>/dev/null); then
+    if [ "$(pct status $CTID | awk '{print $2}')" == "running" ]; then
+      pct stop $CTID
+    fi
+    pct destroy $CTID
+  elif [ "$(pvesm list $STORAGE --vmid $CTID)" != "" ]; then
+    pvesm free $ROOTFS
+  fi
+}
+function cleanup() {
+  popd >/dev/null
+  rm -rf $TEMP_DIR
+}
+TEMP_DIR=$(mktemp -d)
+pushd $TEMP_DIR >/dev/null
+
+export CTID=$(pvesh get /cluster/nextid)
+export PCT_OSTYPE=debian
+export PCT_OSVERSION=11
+export PCT_DISK_SIZE=4
+export PCT_OPTIONS="
+  -features nesting=1
+  -hostname node-red
+  -net0 name=eth0,bridge=vmbr0,ip=dhcp
+  -onboot 1
+  -cores 1
+  -memory 1024
+  -unprivileged 1
+"
+bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/unprev/create_lxc.sh)" || exit
+
+STORAGE_TYPE=$(pvesm status -storage $(pct config $CTID | grep rootfs | awk -F ":" '{print $2}') | awk 'NR>1 {print $2}')
+if [ "$STORAGE_TYPE" == "zfspool" ]; then
+  warn "Some addons may not work due to ZFS not supporting 'fallocate'."
+fi
+
+echo -en "${GN} Starting LXC Container... "
+pct start $CTID
+echo -e "${CM}${CL} \r"
+
+alias lxc-cmd="lxc-attach -n $CTID --"
+
+bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/unprev/node-red-install.sh)" || exit
+
+IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
+
+echo -e "${GN}Successfully created Node-Red LXC to${CL} ${BL}$CTID${CL}."
+${RD}Node-Red${CL} is reachable by going to the following URL.
+
+         ${BL}http://${IP}:1880${CL} \n"